"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Search = function () {
  function Search() {
    _classCallCheck(this, Search);
  }

  _createClass(Search, null, [{
    key: "sequentialSearch",


    /**
     * Sequentially search an item in the array
     * Complexity: Θ(n)
     * Space Complexity: O(n)
     * @method sequentialSearch
     * @param {Array} array - input array
     * @param {Object} item - target item to be searched
     * @return {Integer} index of the item if founded
     */
    value: function sequentialSearch(array, item) {
      if (!array || array.length === 0) {
        return -1;
      }
      for (var i = 0; i < array.length; i += 1) {
        if (item === array[i]) {
          return i;
        }
      }
      return -1;
    }

    /**
     * Binary search an item in the array
     * Complexity: Θ(log(n))
     * Space Complexity: O(n)
     * @method binarySearch
     * @param {Array} array - input array
     * @param {Object} item - target item to be searched
     * @return {Integer} index of the item if founded
     */

  }, {
    key: "binarySearch",
    value: function binarySearch(array, item) {
      if (!array || array.length === 0) {
        return -1;
      }
      var low = 0;
      var high = array.length - 1;
      var mid = void 0;
      var element = void 0;

      while (low <= high) {
        mid = Math.floor((low + high) / 2);
        element = array[mid];
        if (element < item) {
          low = mid + 1;
        } else if (element > item) {
          high = mid - 1;
        } else {
          return element === item ? mid : -1;
        }
      }

      return -1;
    }
  }]);

  return Search;
}();

module.exports = Search;